SystemOrganization addCategory: #'GMF-UMLModel'!

Object subclass: #TransformToUML
	instanceVariableNames: 'dataToTransform element transformedElements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-UMLModel'!

!TransformToUML class methodsFor: 'instance creation' stamp: 'Anonymous 5/8/2013 18:16'!
dataToTransform: xData

	^(super new initialize)
		dataToTransform: xData;
		yourself! !

!TransformToUML methodsFor: 'accessing' stamp: 'Anonymous 5/8/2013 18:15'!
dataToTransform
	^ dataToTransform! !

!TransformToUML methodsFor: 'accessing' stamp: 'Anonymous 5/8/2013 18:16'!
dataToTransform: anObject
	dataToTransform := anObject! !

!TransformToUML methodsFor: 'accessing' stamp: 'Anonymous 5/8/2013 17:59'!
element
	^ element! !

!TransformToUML methodsFor: 'accessing' stamp: 'Anonymous 5/8/2013 17:59'!
element: anObject
	element := anObject! !

!TransformToUML methodsFor: 'private' stamp: 'Anonymous 5/9/2013 08:33'!
findElement: xClass 
      "najdenie elementu v datach spacifickeho typu xClass"
	dataToTransform do: [ :b | b isTransformed not & ( b class = xClass ) ifTrue: [ element := b. ^true. ] ].
	^false.! !

!TransformToUML methodsFor: 'private' stamp: 'Anonymous 5/9/2013 16:17'!
findElement: xClass name: xName
      "najdenie elementu v datach spacifickeho typu xClass a name xName"
	dataToTransform do: [ :b | b isTransformed not & ( b class = xClass ) & ( b name = xName ) ifTrue: [ ^b. ] ].
	^nil.! !

!TransformToUML methodsFor: 'private' stamp: 'Anonymous 5/9/2013 16:26'!
findTransformedElement: xName
      "najdenie elementu v uz transformovanych elementoch spacifickeho typu xClass a name xName"
	transformedElements do: [ :b | ( b name = xName ) ifTrue: [ ^b. ] ].
	^nil.! !

!TransformToUML methodsFor: 'initialize-release' stamp: 'Anonymous 5/8/2013 18:00'!
initialize
	"set numbers of used classes and relations to empty"

	transformedElements := OrderedCollection  new.
	
	^ self! !

!TransformToUML methodsFor: 'private' stamp: 'Anonymous 5/9/2013 08:35'!
isTransformed
	"prejdenie celej kolekce dat a zistenie ci su vsetky elementy prevedene"
	^dataToTransform allSatisfy: [:b | b isTransformed ].! !

!TransformToUML methodsFor: 'private' stamp: 'Anonymous 5/9/2013 08:33'!
readNextElement
	"nacitanie noveho elementu v poradi z data na transform"
	element := dataToTransform detect: [ :b | b isTransformed not ].! !

!TransformToUML methodsFor: 'methods' stamp: 'Anonymous 5/9/2013 08:43'!
transformAll
	"prevedenie vsetkych elementov najprv Category a kind a potom ostatne"
	[ self findElement: Category ] whileTrue: [ 
 	  	self transformElement.	  
	].
	
	[ self findElement: Kind ] whileTrue: [ 
 	  	self transformElement.	  
	].


	[self isTransformed] whileFalse: [
		self readNextElement.
		self transformElement. ]! !

!TransformToUML methodsFor: 'private' stamp: 'Anonymous 5/9/2013 15:55'!
transformElement
	| tmp attributs methods xParent |
	"transformovanie elementu z onto uml do uml"
	( element parent notNil )
		ifTrue: [ 
			xParent := self transformElement: element parent.
			tmp := UMLElement name: element name parent: xParent ]
		ifFalse: [ tmp := UMLElement name: element name. ].
		
	methods := element methods copy.
	tmp methods: methods.
	attributs := element attributs copy.
	tmp attributs: attributs.
	
	element isTransformed: true.
	transformedElements add: tmp.
		
! !

!TransformToUML methodsFor: 'private' stamp: 'Anonymous 5/9/2013 16:26'!
transformElement: xElement
	| tmp xParent tmp2 |
	"transformovanie elementu xElement z onto uml do uml"
	tmp := self findTransformedElement: xElement name.
	( tmp notNil )
		ifTrue: [ ^tmp ].
	
	tmp2 := self findElement: xElement class name: xElement name.
	
	( tmp2 parent notNil )
		ifTrue: [ 
			xParent := self transformElement: element parent.
			tmp := UMLElement name: tmp2 name parent: xParent ]
		ifFalse: [ tmp := UMLElement name: tmp2 name. ].
	
	tmp2 isTransformed: true.
	transformedElements add: tmp.
	^tmp.
		
! !

!TransformToUML methodsFor: 'accessing' stamp: 'Anonymous 5/8/2013 17:59'!
transformedElements
	^ transformedElements! !

!TransformToUML methodsFor: 'accessing' stamp: 'Anonymous 5/8/2013 17:59'!
transformedElements: anObject
	transformedElements := anObject! !

Object subclass: #UMLCompositions
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-UMLModel'!

Object subclass: #UMLElement
	instanceVariableNames: 'attributs methods compositions parent name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GMF-UMLModel'!

!UMLElement class methodsFor: 'instance creation' stamp: 'Anonymous 5/8/2013 17:57'!
name: xName

	^(super new initialize)
		name: xName;
		parent: nil;
		yourself! !

!UMLElement class methodsFor: 'instance creation' stamp: 'Anonymous 5/8/2013 17:57'!
name: xName parent: xParent

	^(super new initialize)
		name: xName;
		parent: xParent;
		yourself! !

!UMLElement methodsFor: 'accessing' stamp: 'Anonymous 5/8/2013 17:47'!
attributs
	^ attributs! !

!UMLElement methodsFor: 'accessing' stamp: 'Anonymous 5/8/2013 17:47'!
attributs: anObject
	attributs := anObject! !

!UMLElement methodsFor: 'accessing' stamp: 'Anonymous 5/8/2013 17:47'!
compositions
	^ compositions! !

!UMLElement methodsFor: 'accessing' stamp: 'Anonymous 5/8/2013 17:47'!
compositions: anObject
	compositions := anObject! !

!UMLElement methodsFor: 'initialize-release' stamp: 'Anonymous 5/8/2013 17:52'!
initialize
	"set numbers of used classes and relations to empty"

	attributs := OrderedCollection new.
	methods := OrderedCollection new.
	compositions := OrderedCollection new.
	
	^ self! !

!UMLElement methodsFor: 'accessing' stamp: 'Anonymous 5/8/2013 17:48'!
methods
	^ methods! !

!UMLElement methodsFor: 'accessing' stamp: 'Anonymous 5/8/2013 17:48'!
methods: anObject
	methods := anObject! !

!UMLElement methodsFor: 'accessing' stamp: 'Anonymous 5/8/2013 17:48'!
name
	^ name! !

!UMLElement methodsFor: 'accessing' stamp: 'Anonymous 5/8/2013 17:48'!
name: anObject
	name := anObject! !

!UMLElement methodsFor: 'accessing' stamp: 'Anonymous 5/8/2013 17:48'!
parent
	^ parent! !

!UMLElement methodsFor: 'accessing' stamp: 'Anonymous 5/8/2013 17:48'!
parent: anObject
	parent := anObject! !
